gtkmm: Gtk::CellRendererToggle Class Reference

gtkmm 4.14.0

Public Member Functions | Static Public Member Functions | Public Attributes | Related Symbols | List of all members
Gtk::CellRendererToggle Class Reference
TreeView Classes

Renders a toggle button in a cell. More...

`#include <gtkmm/cellrenderertoggle.h>`

Inheritance diagram for Gtk::CellRendererToggle:
[legend]

## Public Member Functions
| CellRendererToggle (CellRendererToggle &&src) noexcept
CellRendererToggle & | operator= (CellRendererToggle &&src) noexcept
| CellRendererToggle (const CellRendererToggle &)=delete
CellRendererToggle & | operator= (const CellRendererToggle &)=delete
| ~CellRendererToggle () noexcept override
GtkCellRendererToggle * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellRendererToggle * | gobj () const
| Provides access to the underlying C GObject.
| CellRendererToggle ()
bool | get_radio () const
| Returns whether we’re rendering radio toggles rather than checkboxes.
void | set_radio (bool radio=true)
| If radio is `true`, the cell renderer renders a radio toggle (i.e. a toggle in a group of mutually-exclusive toggles).
bool | get_active () const
| Returns whether the cell renderer is active.
void | set_active (bool setting=true)
| Activates or deactivates a cell renderer.
bool | get_activatable () const
| Returns whether the cell renderer is activatable.
void | set_activatable (bool setting=true)
| Makes the cell renderer activatable.
Glib::PropertyProxy< bool > | property_activatable ()
| Default value: `true`
Glib::PropertyProxy_ReadOnly< bool > | property_activatable () const
| Default value: `true`
Glib::PropertyProxy< bool > | property_active ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_active () const
| Default value: `false`
Glib::PropertyProxy< bool > | property_inconsistent ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_inconsistent () const
| Default value: `false`
Glib::PropertyProxy< bool > | property_radio ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_radio () const
| Default value: `false`
Public Member Functions inherited from Gtk::CellRenderer
| CellRenderer (CellRenderer &&src) noexcept
CellRenderer & | operator= (CellRenderer &&src) noexcept
| CellRenderer (const CellRenderer &)=delete
CellRenderer & | operator= (const CellRenderer &)=delete
| ~CellRenderer () noexcept override
GtkCellRenderer * | gobj ()
| Provides access to the underlying C GObject.
const GtkCellRenderer * | gobj () const
| Provides access to the underlying C GObject.
SizeRequestMode | get_request_mode () const
| Gets whether the cell renderer prefers a height-for-width layout or a width-for-height layout.
void | get_preferred_width (Widget &widget, int &minimum_width, int &natural_width) const
| Retrieves a renderer’s natural size when rendered to widget.
void | get_preferred_height_for_width (Widget &widget, int width, int &minimum_height, int &natural_height) const
| Retrieves a cell renderers’s minimum and natural height if it were rendered to widget with the specified width.
void | get_preferred_height (Widget &widget, int &minimum_height, int &natural_height) const
| Retrieves a renderer’s natural size when rendered to widget.
void | get_preferred_width_for_height (Widget &widget, int height, int &minimum_width, int &natural_width) const
| Retrieves a cell renderers’s minimum and natural width if it were rendered to widget with the specified height.
void | get_preferred_size (Widget &widget, Requisition &minimum_size, Requisition &natural_size) const
| Retrieves the minimum and natural size of a cell taking into account the widget’s preference for height-for-width management.
Gdk::Rectangle | get_aligned_area (Widget &widget, CellRendererState flags, const Gdk::Rectangle &cell_area) const
| Gets the aligned area used by this CellRenderer inside cell_area.
void | snapshot (const Glib::RefPtr< Gtk::Snapshot > & snapshot, Widget &widget, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
| Invokes the virtual render function of the `Gtk::CellRenderer`.
bool | activate (const Glib::RefPtr< const Gdk::Event > & event, Widget &widget, const Glib::ustring & path, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
| Passes an activate event to the cell renderer for possible processing.
CellEditable * | start_editing (const Glib::RefPtr< const Gdk::Event > & event, Widget &widget, const Glib::ustring & path, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags=CellRendererState(0))
| Starts editing the contents of this cell, through a new `Gtk::CellEditable` widget created by the `Gtk::CellRenderer`Class.start_editing virtual function.
void | set_fixed_size (int width, int height)
| Sets the renderer size to be explicit, independent of the properties set.
void | get_fixed_size (int & width, int &height) const
| Fills in width and height with the appropriate size of cell.
void | set_alignment (float xalign, float yalign)
| Sets the renderer’s alignment within its available space.
void | get_alignment (float &xalign, float &yalign) const
| Fills in xalign and yalign with the appropriate values of cell.
void | set_padding (int xpad, int ypad)
| Sets the renderer’s padding.
void | get_padding (int &xpad, int &ypad) const
| Fills in xpad and ypad with the appropriate values of cell.
void | set_visible (bool visible=true)
| Sets the cell renderer’s visibility.
bool | get_visible () const
| Returns the cell renderer’s visibility.
void | set_sensitive (bool sensitive=true)
| Sets the cell renderer’s sensitivity.
bool | get_sensitive () const
| Returns the cell renderer’s sensitivity.
bool | is_activatable () const
| Checks whether the cell renderer can do something when activated.
void | set_is_expander (bool is_expander=true)
| Sets whether the given `Gtk::CellRenderer` is an expander.
bool | get_is_expander () const
| Checks whether the given `Gtk::CellRenderer` is an expander.
void | set_is_expanded (bool is_expanded=true)
| Sets whether the given `Gtk::CellRenderer` is expanded.
bool | get_is_expanded () const
| Checks whether the given `Gtk::CellRenderer` is expanded.
void | stop_editing (bool canceled=false)
| Informs the cell renderer that the editing is stopped.
StateFlags | get_state (Widget &widget, CellRendererState cell_state) const
| Translates the cell renderer state to `Gtk::StateFlags`, based on the cell renderer and widget sensitivity, and the given `Gtk::CellRenderer`State.
StateFlags | get_state (CellRendererState cell_state) const
| A get_state() convenience overload.
Glib::SignalProxy< void()> | signal_editing_canceled ()
Glib::PropertyProxy< CellRendererMode > | property_mode ()
| Default value: Gtk::CellRendererMode::INERT.
Glib::PropertyProxy_ReadOnly< CellRendererMode > | property_mode () const
| Default value: Gtk::CellRendererMode::INERT.
Glib::PropertyProxy< bool > | property_visible ()
| Default value: `true`
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Default value: `true`
Glib::PropertyProxy< bool > | property_sensitive ()
| Default value: `true`
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Default value: `true`
Glib::PropertyProxy< float > | property_xalign ()
| Default value: 0.5.
Glib::PropertyProxy_ReadOnly< float > | property_xalign () const
| Default value: 0.5.
Glib::PropertyProxy< float > | property_yalign ()
| Default value: 0.5.
Glib::PropertyProxy_ReadOnly< float > | property_yalign () const
| Default value: 0.5.
Glib::PropertyProxy< unsigned int > | property_xpad ()
| Default value: 0.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_xpad () const
| Default value: 0.
Glib::PropertyProxy< unsigned int > | property_ypad ()
| Default value: 0.
Glib::PropertyProxy_ReadOnly< unsigned int > | property_ypad () const
| Default value: 0.
Glib::PropertyProxy< int > | property_width ()
| Default value: -1.
Glib::PropertyProxy_ReadOnly< int > | property_width () const
| Default value: -1.
Glib::PropertyProxy< int > | property_height ()
| Default value: -1.
Glib::PropertyProxy_ReadOnly< int > | property_height () const
| Default value: -1.
Glib::PropertyProxy< bool > | property_is_expander ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_is_expander () const
| Default value: `false`
Glib::PropertyProxy< bool > | property_is_expanded ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_is_expanded () const
| Default value: `false`
Glib::PropertyProxy_WriteOnly< Glib::ustring > | property_cell_background ()
| Default value: "".
Glib::PropertyProxy< Gdk::RGBA > | property_cell_background_rgba ()
| Cell background as a `GdkRGBA`
Glib::PropertyProxy_ReadOnly< Gdk::RGBA > | property_cell_background_rgba () const
| Cell background as a `GdkRGBA`
Glib::PropertyProxy< bool > | property_cell_background_set ()
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_cell_background_set () const
| Default value: `false`
Glib::PropertyProxy_ReadOnly< bool > | property_editing () const
| Default value: `false`
Public Member Functions inherited from Gtk::Object
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
| ~Object () noexcept override

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::CellRenderer
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Public Attributes
Glib::SignalProxy< void(const Glib::ustring &) | signal_toggled )()
Public Attributes inherited from Gtk::CellRenderer
Glib::SignalProxy< void(CellEditable *, const Glib::ustring &) | signal_editing_started )()

## Related Symbols
(Note that these are not member symbols.)
Gtk::CellRendererToggle * | wrap (GtkCellRendererToggle *object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::CellRenderer
Gtk::CellRenderer * | wrap (GtkCellRenderer *object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Protected Member Functions inherited from Gtk::CellRenderer
| CellRenderer ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (Widget &widget, int &minimum_width, int &natural_width) const
virtual void | get_preferred_height_for_width_vfunc (Widget &widget, int width, int &minimum_height, int &natural_height) const
virtual void | get_preferred_height_vfunc (Widget &widget, int &minimum_height, int &natural_height) const
virtual void | get_preferred_width_for_height_vfunc (Widget &widget, int height, int &minimum_width, int &natural_width) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > &snapshot, Widget &widget, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
virtual bool | activate_vfunc (const Glib::RefPtr< const Gdk::Event > & event, Widget &widget, const Glib::ustring & path, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
virtual CellEditable * | start_editing_vfunc (const Glib::RefPtr< const Gdk::Event > & event, Widget &widget, const Glib::ustring & path, const Gdk::Rectangle &background_area, const Gdk::Rectangle &cell_area, CellRendererState flags)
virtual void | on_editing_canceled ()
| This is a default handler for the signal signal_editing_canceled().
virtual void | on_editing_started (CellEditable * editable, const Glib::ustring & path)
| This is a default handler for the signal signal_editing_started().

## Detailed Description

Renders a toggle button in a cell.

The button is drawn as a radio- or checkbutton, depending on the radio property. When activated, it emits the toggled signal.

Deprecated
  4.10: List views use widgets to display their contents. You should use Gtk::ToggleButton instead.

## Constructor & Destructor Documentation

## ◆ CellRendererToggle() [1/3]

Gtk::CellRendererToggle::CellRendererToggle | ( | CellRendererToggle && | src | ) |
| noexcept

## ◆ CellRendererToggle() [2/3]

Gtk::CellRendererToggle::CellRendererToggle | ( | const CellRendererToggle & |  | ) |
| delete

## ◆ ~CellRendererToggle()

Gtk::CellRendererToggle::~CellRendererToggle | ( |  | ) |
| overridenoexcept

## ◆ CellRendererToggle() [3/3]

Gtk::CellRendererToggle::CellRendererToggle | ( |  | ) |

## Member Function Documentation

## ◆ get_activatable()

bool Gtk::CellRendererToggle::get_activatable | ( |  | ) | const

Returns whether the cell renderer is activatable.

See set_activatable().

Deprecated: 4.10

Returns
  `true` if the cell renderer is activatable.

## ◆ get_active()

bool Gtk::CellRendererToggle::get_active | ( |  | ) | const

Returns whether the cell renderer is active.

See set_active().

Deprecated: 4.10

Returns
  `true` if the cell renderer is active.

## ◆ get_radio()

bool Gtk::CellRendererToggle::get_radio | ( |  | ) | const

Returns whether we’re rendering radio toggles rather than checkboxes.

Deprecated: 4.10

Returns
  `true` if we’re rendering radio toggles rather than checkboxes.

## ◆ get_type()

static GType Gtk::CellRendererToggle::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkCellRendererToggle * Gtk::CellRendererToggle::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkCellRendererToggle * Gtk::CellRendererToggle::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ operator=() [1/2]

CellRendererToggle & Gtk::CellRendererToggle::operator= | ( | CellRendererToggle && | src | ) |
| noexcept

## ◆ operator=() [2/2]

CellRendererToggle & Gtk::CellRendererToggle::operator= | ( | const CellRendererToggle & |  | ) |
| delete

## ◆ property_activatable() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRendererToggle::property_activatable | ( |  | ) |

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_activatable() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRendererToggle::property_activatable | ( |  | ) | const

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_active() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRendererToggle::property_active | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_active() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRendererToggle::property_active | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_inconsistent() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRendererToggle::property_inconsistent | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_inconsistent() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRendererToggle::property_inconsistent | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_radio() [1/2]

Glib::PropertyProxy< bool > Gtk::CellRendererToggle::property_radio | ( |  | ) |

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_radio() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::CellRendererToggle::property_radio | ( |  | ) | const

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_activatable()

void Gtk::CellRendererToggle::set_activatable | ( | bool | setting = true | ) |

Makes the cell renderer activatable.

Deprecated: 4.10

Parameters

  setting | The value to set.

## ◆ set_active()

void Gtk::CellRendererToggle::set_active | ( | bool | setting = true | ) |

Activates or deactivates a cell renderer.

Deprecated: 4.10

Parameters

  setting | The value to set.

## ◆ set_radio()

void Gtk::CellRendererToggle::set_radio | ( | bool | radio = true | ) |

If radio is `true`, the cell renderer renders a radio toggle (i.e. a toggle in a group of mutually-exclusive toggles).

If `false`, it renders a check toggle (a standalone boolean option). This can be set globally for the cell renderer, or changed just before rendering each cell in the model (for `Gtk::TreeView`, you set up a per-row setting using `Gtk::TreeViewColumn` to associate model columns with cell renderer properties).

Deprecated: 4.10

Parameters

  radio | `true` to make the toggle look like a radio button.

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::CellRendererToggle * wrap | ( | GtkCellRendererToggle * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

## Member Data Documentation

## ◆ signal_toggled

Glib::SignalProxy< void(const Glib::ustring &) Gtk::CellRendererToggle::signal_toggled) ()

Slot Prototype:
  `void on_my_toggled(const Glib::ustring& path)`

Flags: Run Last

The signal_toggled() signal is emitted when the cell is toggled.

It is the responsibility of the application to update the model with the correct value to store at path. Often this is simply the opposite of the value currently stored at path.

Parameters

  path | String representation of `Gtk::TreePath` describing the event location.